/*=============================================================================
	exFMP7.dllgAPI
=============================================================================*/
#pragma once
#include	"fmp32_api.h"

namespace exFMP7 {

/*-----------------------------------------------------------------------------
	ANZXNX
-----------------------------------------------------------------------------*/
	class FUNC {
	  public:
		enum {								// t@NV
			GET_FILEPATH = 1,				// tt@C擾
			GET_NUMPWI = 2,					// PWI`
		};

		// 擾t@C
		static const int FILE_MUSIC			= 0;
		static const int FILE_PWI			= 1;

	  public:
		FUNC::FUNC(void);
		LPWSTR GetFilePath(int,int);
		int GetNumPWI(void);

	  private:
		FMP32::FUNC* hFMP7;
		WCHAR FilePath[_MAX_PATH +1];
	};

/*-----------------------------------------------------------------------------
	gL
-----------------------------------------------------------------------------*/
	namespace SHM {
		// GUID {5C7D6EB5-4A5F-40ff-8906-D660B6D55E93}
		static const GUID GUID = 
			{ 0x5c7d6eb5, 0x4a5f, 0x40ff,
				{ 0x89, 0x6, 0xd6, 0x60, 0xb6, 0xd5, 0x5e, 0x93 }
			};

		// Ήp[g
		static const int PARTS_FM		= 32;
		static const int PARTS_SSG		= 32;
		static const int PARTS_PCM		= 32;
		static const int PARTS_ALL		= 64;
	};
};
