/*=============================================================================
	exS98P.dllgAPI
=============================================================================*/
#include	<windows.h>
#include	"ex_s98p.h"

namespace exS98P {

/*-----------------------------------------------------------------------------
	RXgN^
-----------------------------------------------------------------------------*/
FUNC::FUNC(
	void
) {
	hFMP7 = GetFMP7Instance();
}

/*-----------------------------------------------------------------------------
	Rg擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetComment(
	void
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_COMMENT, 0, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

/*-----------------------------------------------------------------------------
	thCo
-----------------------------------------------------------------------------*/
DWORD
FUNC::GetDriverInfo(
	int n
) {
	int info;

	if(! hFMP7->CallExAPI(SHM::GUID, GET_DRIVER, n, 0, NULL, 0, &info))
		return(0);

	return(info);
}

/*-----------------------------------------------------------------------------
	t@C擾
-----------------------------------------------------------------------------*/
LPWSTR
FUNC::GetFilePath(
	int kind
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_FILEPATH, kind, 0, FilePath, _MAX_PATH, NULL))
		return(NULL);

	return(FilePath);
}

/*-----------------------------------------------------------------------------
	f[^ʎ擾
-----------------------------------------------------------------------------*/
LPWSTR
FUNC::GetDataInfo(
	int kind,
	DWORD *ret
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_DATAINFO, kind, (DWORD)ret, FilePath, _MAX_PATH, NULL))
		return(NULL);

	return(FilePath);
}

/*-----------------------------------------------------------------------------
	OPNA~LT[l擾
-----------------------------------------------------------------------------*/
int
FUNC::GetMixerOPNA(
	void
) {
	int mix;

	if(! hFMP7->CallExAPI(SHM::GUID, GET_OPNAMIX, 0, 0, NULL, 0, &mix))
		return(-1);

	return(mix);
}

};
