/*=============================================================================
	FMP7JAPI
=============================================================================*/
#pragma once

namespace FMP32 {

/*-----------------------------------------------------------------------------
	u[hLXgbZ[W
-----------------------------------------------------------------------------*/
	namespace MESSAGE {
		static const LPWSTR REGISTER_STRING = L"FMP7 MESSAGE KEY";
		enum {
			START_FMP		= 1,				// N
			END_FMP			= 2,				// I
		};
	};

/*-----------------------------------------------------------------------------
	G[ԍ
-----------------------------------------------------------------------------*/
	namespace ERR {
		enum D {
			NON_ERROR			= 0,		// I
			FMP_NOT_FOUND		= 1,		// FMP7Ȃ
			BUSY				= 2,		// f[^
			OPEN_PROC			= 10,		// ĂяovZXANZXG[
			WRITE_MEMORY		= 11,		// ݃G[
			READ_MEMORY			= 12,		// ǂݍ݃G[
			WORKSIZE_NOMATCH	= 13,		// [NTCYȂ
			WORKSIZE_SHORT		= 14,		// i[[NTCY
			FILE_LOAD			= 15,		// t@Cǂݍ݃G[
			PARAM_RANGE			= 19,		// p[^w͈̓G[
			PART_RANGE			= 20,		// p[gԍwG[
			SEEK_RANGE			= 21,		// V[Nw͈̓G[
			COPY_SIZE_OVER		= 22,		// ő像[NTCYI[o[
			DRIVER_NOT_READY	= 23,		// thCoN
		};
	};

/*-----------------------------------------------------------------------------
	ANZXNX
-----------------------------------------------------------------------------*/
	class FUNC {
	  public:
		virtual BOOL MusicLoad(LPWSTR) = 0;
		virtual BOOL MusicPlay(LPWSTR) = 0;
		virtual BOOL MusicLoad(BYTE*,int) = 0;
		virtual BOOL MusicPlay(BYTE*,int) = 0;
		virtual BOOL MusicPlay(void) = 0;
		virtual BOOL MusicStop(void) = 0;
		virtual BOOL MusicPause(void) = 0;
		virtual BOOL MusicFadeOut(int) = 0;
		virtual BOOL SetMask(int,BOOL) = 0;
		virtual BOOL SetMask(BYTE*) = 0;
		virtual BOOL SetSeek(DWORD) = 0;
		virtual BOOL GetVersion(int*,int*,int*) = 0;
		virtual BOOL GetWorkSize(int*,int*) = 0;
		virtual BOOL GetWorkSize(int*,int*,int*) = 0;
		virtual BOOL CallExAPI(GUID,DWORD,DWORD,DWORD,void*,int,int*) = 0;
		virtual int GetPlayFilename(LPWSTR,int) = 0;
		virtual int GetMusicTitle(LPWSTR,int) = 0;
		virtual int GetMusicCreator(LPWSTR,int) = 0;
		virtual int GetMusicComposer(LPWSTR,int) = 0;
		virtual int GetMusicComment(LPWSTR,int) = 0;
		virtual DWORD GetLastError(void) = 0;
		virtual int GetErrorMessage(LPWSTR,int) = 0;
		virtual int GetExtList(LPWSTR,int,BOOL) = 0;
	};
};

extern FMP32::FUNC* GetFMP7Instance(void);
