/*=============================================================================
	FMP7JL
=============================================================================*/
#pragma once

/*-----------------------------------------------------------------------------
	IuWFNgL[
-----------------------------------------------------------------------------*/
#define FMP32_KEY_MAP		L"FMP7_PUBLIC_WORK"			// map
#define FMP32_KEY_MUTEX		L"FMP7_PUBLIC_WORK_MUTEX"	// mutex

/*-----------------------------------------------------------------------------
	Xe[^Xrbg
-----------------------------------------------------------------------------*/
#define FMP32_STAT_PLAY		0x00000001		// 1:t
#define FMP32_STAT_PAUSE	0x00000002		// 1:ꎞ~
//#define FMP32_STAT_		0x00000004		// 1:
//#define FMP32_STAT_		0x00000008		// 1:
#define FMP32_STAT_FADE		0x00000010		// 1:tF[h
//#define FMP32_STAT_		0x00000020		// 1:
//#define FMP32_STAT_		0x00000040		// 1:
//#define FMP32_STAT_		0x00000080		// 1:
#define FMP32_STAT_LOOP		0x00010000		// 1:[v
#define FMP32_STAT_MASK		0x00020000		// 1:}XNĂp[g

/*-----------------------------------------------------------------------------
	p[g[Nrbg
-----------------------------------------------------------------------------*/
#define FMP32_BIT_PLAY		0x00000001		// 1:t`l
//#define FMP32_BIT_		0x00000002		// 1:
#define FMP32_BIT_KEYON		0x00000004		// 1:L[Ip 0:L[It
#define FMP32_BIT_TAI		0x00000008		// 1:^C쒆
#define FMP32_BIT_SENV		0x00000010		// 1:SOFT ENV쒆
#define FMP32_BIT_HENV		0x00000020		// 1:SSG HARD ENV쒆
#define FMP32_BIT_TONE		0x00000040		// 1:SSG g[
#define FMP32_BIT_NOISE		0x00000080		// 1:SSG mCY
#define FMP32_BIT_LFO0		0x00000100		// 1:LFO-0 on
#define FMP32_BIT_LFO1		0x00000200		// 1:LFO-1 on
#define FMP32_BIT_LFO2		0x00000400		// 1:LFO-2 on
#define FMP32_BIT_LFO3		0x00000800		// 1:LFO-3 on
#define FMP32_BIT_PBEND		0x00001000		// 1:sb`xh쓮
#define FMP32_BIT_TBEND		0x00002000		// 1:g[xh쓮
//#define FMP32_BIT_		0x00004000		// 1:
//#define FMP32_BIT_		0x00008000		// 1:

/*-----------------------------------------------------------------------------
	LFOʒ`

 LFOn		HHHHHHHHHHHH LLLL

 LOW̓rbgɕύX(ver7.10-)
#define FMP32_LFO_L_VIBRATO		0x00		// ru[g
#define FMP32_LFO_L_TREMOLO		0x01		// g
#define FMP32_LFO_L_WOW			0x02		// E
#define FMP32_LFO_L_PAN			0x03		// I[gp
#define FMP32_LFO_L_NOISE		0x04		// mCY
#define FMP32_LFO_L_BUILTIN		0x08		// n[hEFA
-----------------------------------------------------------------------------*/
#define FMP32_LFO_H_VIBRATO		0x0010		// ru[g
#define FMP32_LFO_H_TREMOLO		0x0020		// g
#define FMP32_LFO_H_WOW			0x0040		// E
#define FMP32_LFO_H_PAN			0x0080		// I[gp
#define FMP32_LFO_H_NOISE		0x0100		// mCY
#define FMP32_LFO_H_BUILTIN		0x8000		// n[hEFA

#define FMP32_LFO_L_TRIANGLE 	0x0000		// Opg
#define FMP32_LFO_L_SAW			0x0001		// ̂g
#define FMP32_LFO_L_SQUARE		0x0002		// `g
#define FMP32_LFO_L_ONESHOT		0x0003		// Vbg
#define FMP32_LFO_L_RANDOM		0x0004		// _

/*-----------------------------------------------------------------------------
	p[g[hʒ`
-----------------------------------------------------------------------------*/
#define FMP32_MODE_NON				0x00	// gp
#define FMP32_MODE_FM				0x01	// FM
#define FMP32_MODE_SSG				0x02	// SSG
#define FMP32_MODE_PCM				0x03	// PCM

/*-----------------------------------------------------------------------------
	ʒ`
-----------------------------------------------------------------------------*/
#define FMP32_DEVICE_NON			0x00	// gp
#define FMP32_DEVICE_OPNA			0x01	// OPNA
#define FMP32_DEVICE_OPM			0x02	// OPM
#define FMP32_DEVICE_OPL			0x03	// OPL
#define FMP32_DEVICE_SSG			0x10	// SSG
#define FMP32_DEVICE_PCM			0x20	// PCM
#define FMP32_DEVICE_ADPCM			0x21	// ADPCM
#define FMP32_DEVICE_RHYTHM			0x30	// Y

/*-----------------------------------------------------------------------------
	TCY
-----------------------------------------------------------------------------*/
#define FMP32_MAX_PART				128		// őp[g

#pragma pack(1)
/*-----------------------------------------------------------------------------
	O[o[N
-----------------------------------------------------------------------------*/
typedef struct tFMP32_GLOBALWORK {
	DWORD	Status;						// (Xe[^XrbgQ)
	DWORD	PlayTime;					// tp
	DWORD	AverageCalorie;				// J[liρj
	DWORD	InstantCalorie;				// J[liuԁj
	DWORD	Count;						// ȑŜ̒
	DWORD	CountNow;					// ݂̉tʒu
	DWORD	Tempo;						// e|
	DWORD	Loop;						// [v
	BYTE	Mode[FMP32_MAX_PART];		// p[g[h (p[g[hʒ`Q)
	BYTE	PartNo[FMP32_MAX_PART];		// p[gԍ(1-32)
	BYTE	Mask[FMP32_MAX_PART];		// p[g}XN
	short	LevelL;						// Đxij
	short	LevelR;						// ĐxiEj
	DWORD	Clock;						// SNbN
	DWORD	StartCounter;				// tJnƂɁ{P
	GUID	nGUID;						// 쉹GUID
	DWORD	DriverVer;					// 쉹hCoo[W
	BYTE	Device[FMP32_MAX_PART];		// ʁiʒ`QƁj
} FMP32_GLOBALWORK, *PFMP32_GLOBALWORK;

/*-----------------------------------------------------------------------------
	p[g[N\
-----------------------------------------------------------------------------*/
typedef struct tFMP32_PARTWORK {
	DWORD	State;			// +00:ԃtOibit`QƁj

	BYTE	dmy0[4];		// +04:LFOʒ`

	short	Freq;			// +08:݂̔_g 0 ` 6912 (64c * 108K)
							// (freq - 64) 
	short	Detune;			// +0A:f`[l -6143 ` 0 ` +6143

	WORD	Hfreq;			// +0C:HARD ENV freq(SSGȊO͏0)
	WORD	EnvNo;			// +0E:Gx[vԍ(FM͏0)

	WORD	Count;			// +10:JEg
	WORD	CountNow;		// +12:cJEg(0~65535)

	BYTE	Keyon;			// +14:keyonɃCNg(++)
	BYTE	Note;			// +15: o1c=0 ` o9b=108 rest=255
	BYTE	Tone;			// +16:Fԍ 0~255
	BYTE	Vol;			// +17:ʒl 0~127

	BYTE	Pan;			// +18:pl 1(R)`128(C)`255(L)
	BYTE	Noise;			// +19:SSGmCYg(SSGȊO͏0)
	char	KeyTrans;		// +1A:L[gX|[Y(-95`95)
	BYTE	dmy2[1];		// +1B:

	BYTE	dmy3[4];		// +1C:

	WORD	LFO0;			// +20:LFOڍ׎ (LFOʒ`Q)
	WORD	LFO1;			// +22:LFOڍ׎ (LFOʒ`Q)
	WORD	LFO2;			// +24:LFOڍ׎ (LFOʒ`Q)
	WORD	LFO3;			// +26:LFOڍ׎ (LFOʒ`Q)

	BYTE	dmy4[8];		// +28:
} FMP32_PARTWORK, *PFMP32_PARTWORK;

/*-----------------------------------------------------------------------------
	g񃏁[NL
-----------------------------------------------------------------------------*/
typedef void FMP32_EXWORK, *PFMP32_EXWORK;

#pragma pack()
