/*=============================================================================
	FMP7JAPI
=============================================================================*/
#pragma once
#include	"fmp32_api.h"

/*-----------------------------------------------------------------------------
	ANZXNX
-----------------------------------------------------------------------------*/
class FMP7API :
	public FMP32::FUNC {

  public:
/*-----------------------------------------------------------------------------
	擾eLXg

 FMP32_API_GETTEXTHIWORD
-----------------------------------------------------------------------------*/
	class TEXT {
	  public:
		enum {
			TITLE			= 0x0000,			// ^Cg
			CREATOR			= 0x0001,			// f[^
			COMPOSER		= 0x0002,			// Ȏ
			FILENAME		= 0x0010,			// tt@C
			COMMENT			= 0x0100,			// Rg
			DETAILERRMSG	= 0x1000,			// G[bZ[W
			EXTLIST			= 0x2000,			// ΉgqXg
		};
	};

/*-----------------------------------------------------------------------------
	lpData\
-----------------------------------------------------------------------------*/
	struct APIINFO {
		int size;
		DWORD pid;
		BYTE* data;
	};

/*-----------------------------------------------------------------------------
	APIԍ LOWORD
-----------------------------------------------------------------------------*/
	class API {
	  public:
		enum {
			MUSICLOAD		= 0x0001,			// t@Cǂݍ
			MUSICPLAY		= 0x0002,			// tJn
			MUSICSTOP		= 0x0003,			// t~
			MUSICPAUSE		= 0x0004,			// tꎞf
			MUSICFADE		= 0x0005,			// tF[hAEg
			MUSICLOAD2		= 0x0006,			// f[^ǂݍ
			SETMASK			= 0x0010,			// p[g}XNw
			SETSEEK			= 0x0011,			// V[Nʒuw
			GETVERSION		= 0x0100,			// hCoo[W
			GETWORKSIZE		= 0x0101,			// J[NTCY擾
			GETDETAIL		= 0x0110,			// ڍ׃G[R[h擾
			GETTEXT			= 0x0200,			// tt@C擾
			GETTEXTLEN		= 0x0201,			// tt@C񕶎
			CALLEXAPI		= 0x1000,			// gAPIR[
		};
	};

/*-----------------------------------------------------------------------------
	ǂݍ݌㓮w

 FMP32_API_MUSICLOADHIWORD
-----------------------------------------------------------------------------*/
	class LOAD {
	  public:
		enum {
			ONLY			= 0x0000,			// ǂݍ݂̂
			PLAY			= 0x0001,			// ǂݍ݌㉉t
		};
	};

/*-----------------------------------------------------------------------------
	}XNw

 FMP32_API_SETMASKHIWORD
-----------------------------------------------------------------------------*/
	class MASK {
	  public:
		enum {
			SINGLE_PART		= 0x0000,			// P
			ALL_PART		= 0x0001,			// S
		};
	};

/*-----------------------------------------------------------------------------
	ExAPIp[^\
-----------------------------------------------------------------------------*/
	struct EXAPIINFO {
		GUID guid;
		DWORD func;
		DWORD ex1;
		DWORD ex2;
		DWORD ex3_size;
		int ret;
		BYTE ex3[1];
	};

  private:
/*-----------------------------------------------------------------------------
	AvP[V
-----------------------------------------------------------------------------*/
	static const LPWSTR APPNAME;

/*-----------------------------------------------------------------------------
	G[bZ[W
-----------------------------------------------------------------------------*/
	struct MSGTBL {
		DWORD Code;
		LPWSTR pMess;
	};
	static const MSGTBL ErrMSG[];

  public:
	FMP7API::FMP7API(void);

	DWORD GetLastError(void);
	int GetErrorMessage(LPWSTR,int);
	int GetExtList(LPWSTR,int,BOOL);

	BOOL MusicLoad(LPWSTR);
	BOOL MusicPlay(LPWSTR);
	BOOL MusicLoad(BYTE*,int);
	BOOL MusicPlay(BYTE*,int);
	BOOL MusicPlay(void);
	BOOL MusicStop(void);
	BOOL MusicPause(void);
	BOOL MusicFadeOut(int);
	BOOL SetMask(int,BOOL);
	BOOL SetMask(BYTE*);
	BOOL SetSeek(DWORD);
	BOOL GetVersion(int*,int*,int*);
	BOOL GetWorkSize(int*,int*);
	BOOL GetWorkSize(int*,int*,int*);
	int GetPlayFilename(LPWSTR,int);
	int GetMusicTitle(LPWSTR,int);
	int GetMusicCreator(LPWSTR,int);
	int GetMusicComposer(LPWSTR,int);
	int GetMusicComment(LPWSTR,int);
	BOOL CallExAPI(GUID,DWORD,DWORD,DWORD,void*,int,int*);

  private:
	int GetTextData(LPWSTR,int,int);
	BOOL Send(int,int,BYTE*,int);
	BOOL Send(int,int);
	DWORD dwLastError;
	DWORD dwPID;
};
