/*=============================================================================
	exFMP4.dllgAPI
=============================================================================*/
#include	<windows.h>
#include	"ex_fmp4.h"

namespace exFMP4 {

/*-----------------------------------------------------------------------------
	RXgN^
-----------------------------------------------------------------------------*/
FUNC::FUNC(
	void
) {
	hFMP7 = GetFMP7Instance();
}

/*-----------------------------------------------------------------------------
	Rg擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetComment(
	void
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_COMMENT, 0, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

/*-----------------------------------------------------------------------------
	RgJE^擾
-----------------------------------------------------------------------------*/
int
FUNC::GetSyncCounter(
	void
) {
	int sync;

	if(! hFMP7->CallExAPI(SHM::GUID, GET_SYNC, 0, 0, NULL, 0, &sync))
		return(-1);

	return(sync);
}

/*-----------------------------------------------------------------------------
	thCo
-----------------------------------------------------------------------------*/
DWORD
FUNC::GetDriverInfo(
	void
) {
	int info;

	if(! hFMP7->CallExAPI(SHM::GUID, GET_DRIVER, 0, 0, NULL, 0, &info))
		return(0);

	return(info);
}

/*-----------------------------------------------------------------------------
	PCMt@C擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetFilePath(
	int kind
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_FILEPATH, kind, 0, FilePath, _MAX_PATH, NULL))
		return(NULL);

	return(FilePath);
}

};
