/*=============================================================================
	exPMD.dllgAPI
=============================================================================*/
#include	<windows.h>
#include	"ex_pmd.h"

namespace exPMD {

/*-----------------------------------------------------------------------------
	RXgN^
-----------------------------------------------------------------------------*/
FUNC::FUNC(
	void
) {
	hFMP7 = GetFMP7Instance();
}

/*-----------------------------------------------------------------------------
	#title,#composer,#arranger擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetTitle(
	void
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_MEMO, 1, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

char*
FUNC::GetComposer(
	void
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_MEMO, 2, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

char*
FUNC::GetArranger(
	void
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_MEMO, 3, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

/*-----------------------------------------------------------------------------
	擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetMemo(
	int no
) {
	if(no < 1 && no > 128)
		return(NULL);
	if(! hFMP7->CallExAPI(SHM::GUID, GET_MEMO, 3 +no, 0, CommentBuff, COMMENT_SIZE, NULL))
		return(NULL);

	return(CommentBuff);
}

/*-----------------------------------------------------------------------------
	thCo
-----------------------------------------------------------------------------*/
DWORD
FUNC::GetDriverInfo(
	void
) {
	int info;

	if(! hFMP7->CallExAPI(SHM::GUID, GET_DRIVER, 0, 0, NULL, 0, &info))
		return(0);

	return(info);
}

/*-----------------------------------------------------------------------------
	t@C擾
-----------------------------------------------------------------------------*/
char*
FUNC::GetFilePath(
	int kind
) {
	if(! hFMP7->CallExAPI(SHM::GUID, GET_FILEPATH, kind, 0, FilePath, _MAX_PATH, NULL))
		return(NULL);

	return(FilePath);
}

};
