/*=============================================================================
	MMLRpCRg[wb_
=============================================================================*/
#pragma once

namespace FMC32 {

	// RpCtO
	enum eCFLAG {
		ONLY_PREPRO				= 0x00000001,	// WJ`FbN̂
		ONLY_COMPILE			= 0x00000002,	// RpC`FbN̂
		PLAY_AFTER				= 0x00000100,	// RpC㎩t
	};

	// RpCXe[^X
	enum eSTATUS {
		SUCCESS						= 0,		// I
		ERROR_COMPILE				= 1,		// RpCG[
		ERROR_FILE_OPEN				= 2,		// t@CI[vG[
		ERROR_READ_FILE				= 3,		// ǂݍ݃G[
		ERROR_WRITE_FILE			= 4,		// ݃G[
		ERROR_DELETE_FILE			= 5,		// 폜G[
		ERROR_NODATA				= 6,		// Lȃf[^Ȃ
		ERROR_PLAY					= 7,		// f[^tG[
	};

	// RpC
	enum eKIND {
		KIND_FILE					= 0,		// t@C
		KIND_PART					= 1,		// p[g
		KIND_LOG					= 2,		// RpCO
		KIND_INFO					= 3,		// CtH[V
	};
	// ^Cv
	enum eTYPE {
		TYPE_OPNA					= 0,		// OPNA
		TYPE_SSG					= 1,		// SSG
		TYPE_PCM					= 2,		// PCM
		TYPE_OPM					= 3,		// OPM
	};
	// O񎯕
	enum eLKIND {
		LKIND_ERROR					= 0,		// G[
		LKIND_WARN					= 1,		// [jO
		LKIND_INFO					= 2,		// 
	};

#pragma pack(1)
	// RpCO
	struct CLOG {
		eLKIND Kind;							// O
		LPWSTR pMessage;						// G[bZ[W
		int nLine;								// G[s
		int nCol;								// G[J
		WCHAR pPart[3];							// p[g
		LPWSTR pFileName;						// G[t@C
		LPWSTR pAliasName;						// GCAX
		LPWSTR pMML;							// YMML
	};
	// p[g
	struct CPART {
		WCHAR pPart[3];							// p[g
		int nType;								// ^Cv
		int nTotal;								// NbN
		int nLoop;								// [vNbN
		int nBytes;								// obyte
	};
	// t@C
	struct CFILE {
		LPWSTR pFileName;						// t@C
		int nPartTotal;							// p[g
		int nPartOPNA;							// OPNAp[g
		int nPartSSG;							// SSGp[g
		int nPartPCM;							// PCMp[g
		int nToneFM4;							// FMF
		int nWavePCM;							// WAVE
		int nEnvelop;							// Gx[v
		int nPartOPM;							// OPMp[g
	};
	// eCtH[V
	struct CINFO {
		LPWSTR pMessage;
	};

	// RpC
	struct INFO {
		int Kind;								// (eKIND)
		union {
			CLOG Log;
			CFILE File;
			CPART Part;
			CINFO Info;
		};
	};
#pragma pack()
}

/*----------------------------------------------------------------------------
	vg^Cv
----------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

extern void __stdcall GetVer(int*,int*,int*);
extern FMC32::eSTATUS __stdcall Compile(LPWSTR,LPWSTR,DWORD);
extern void __stdcall Free(void);
extern int __stdcall GetInfoNum(void);
extern FMC32::INFO* __stdcall GetInfo(int);
extern void __stdcall OptionSetting(HWND);

#ifdef __cplusplus
}
#endif
